Index: /trunk/src/sys/crypto/des/sk.h
===================================================================
--- /trunk/src/sys/crypto/des/sk.h	(revision 151)
+++ /trunk/src/sys/crypto/des/sk.h	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: sk.h,v 1.1 2000/06/14 19:45:36 thorpej Exp $	*/
+/*	$NetBSD: sk.h,v 1.1.1.1 2000/06/14 19:45:36 thorpej Exp $	*/
 /*	$KAME: sk.h,v 1.3 2000/03/27 04:36:34 sumikawa Exp $	*/
 
Index: /trunk/src/sys/dev/ic/com.c
===================================================================
--- /trunk/src/sys/dev/ic/com.c	(revision 151)
+++ /trunk/src/sys/dev/ic/com.c	(revision 152)
@@ -1,3 +1,3 @@
-/* $NetBSD: com.c,v 1.286.10.1 2009/09/13 03:32:33 cliff Exp $ */
+/* com.c,v 1.286.10.1 2009/09/13 03:32:33 cliff Exp */
 
 /*-
@@ -67,5 +67,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: com.c,v 1.286.10.1 2009/09/13 03:32:33 cliff Exp $");
+__KERNEL_RCSID(0, "com.c,v 1.286.10.1 2009/09/13 03:32:33 cliff Exp");
 
 #include "opt_com.h"
@@ -1469,4 +1469,5 @@
 	if (sc->sc_type == COM_TYPE_AU1x00) {
 		/* alchemy has single separate 16-bit clock divisor register */
+		/* XXX endian */
 		CSR_WRITE_2(regsp, COM_REG_DLBL, sc->sc_dlbl +
 		    (sc->sc_dlbh << 8));
@@ -2155,5 +2156,12 @@
 	if (frequency != -1) {
 		rate = comspeed(rate, frequency, type);
-		if (type != COM_TYPE_AU1x00) {
+		if (type == COM_TYPE_AU1x00) {
+			/*
+			 * alchemy has single separate
+			 * 16-bit clock divisor register
+			 * XXX endian
+			 */
+			CSR_WRITE_2(regsp, COM_REG_DLBL, rate);
+		} else {
 			/* no EFR on alchemy */ 
 			if (type != COM_TYPE_16550_NOERS) {
@@ -2164,6 +2172,4 @@
 			CSR_WRITE_1(regsp, COM_REG_DLBL, rate & 0xff);
 			CSR_WRITE_1(regsp, COM_REG_DLBH, rate >> 8);
-		} else {
-			CSR_WRITE_1(regsp, COM_REG_DLBL, rate);
 		}
 	}
Index: /trunk/src/sys/dev/ic/siisata.c
===================================================================
--- /trunk/src/sys/dev/ic/siisata.c	(revision 151)
+++ /trunk/src/sys/dev/ic/siisata.c	(revision 152)
@@ -1,3 +1,3 @@
-/* $NetBSD: siisata.c,v 1.2.14.1 2010/04/21 00:27:37 matt Exp $ */
+/* $NetBSD: siisata.c,v 1.2.14.2 2011/04/29 08:20:50 matt Exp $ */
 
 /* from ahcisata_core.c */
@@ -1194,5 +1194,5 @@
 	sc = (struct siisata_softc *)schp->ata_channel.ch_atac;
 
-	KASSERTMSG(((schp->sch_active_slots & __BIT(slot)) == __BIT(slot)),
+	KASSERTMSG(((schp->sch_active_slots & __BIT(slot)) == 0),
 	    ("%s: trying to activate active slot %d", SIISATANAME(sc), slot));
 
@@ -1216,5 +1216,5 @@
 	sc = (struct siisata_softc *)schp->ata_channel.ch_atac;
 
-	KASSERTMSG(((schp->sch_active_slots & __BIT(slot)) == 0),
+	KASSERTMSG(((schp->sch_active_slots & __BIT(slot)) != 0),
 	    ("%s: trying to deactivate inactive slot %d", SIISATANAME(sc),
 	    slot));
Index: /trunk/src/sys/dev/mii/miidevs
===================================================================
--- /trunk/src/sys/dev/mii/miidevs	(revision 151)
+++ /trunk/src/sys/dev/mii/miidevs	(revision 152)
@@ -1,3 +1,3 @@
-$NetBSD: miidevs,v 1.78.10.2 2010/04/20 22:55:48 matt Exp $
+$NetBSD: miidevs,v 1.78.10.5 2011/05/20 14:41:01 matt Exp $
 
 /*-
@@ -115,4 +115,5 @@
 model ATTANSIC L1		0x0001 L1 10/100/1000 PHY
 model ATTANSIC L2		0x0002 L2 10/100 PHY
+model ATTANSIC AR8316		0x0004 AR8316 Switch
 
 /* Altima Communications PHYs */
Index: /trunk/src/sys/dev/mii/miidevs.h
===================================================================
--- /trunk/src/sys/dev/mii/miidevs.h	(revision 151)
+++ /trunk/src/sys/dev/mii/miidevs.h	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: miidevs.h,v 1.81.10.2 2010/04/21 00:27:39 matt Exp $	*/
+/*	$NetBSD: miidevs.h,v 1.81.10.3 2011/05/20 14:42:20 matt Exp $	*/
 
 /*
@@ -5,5 +5,5 @@
  *
  * generated from:
- *	NetBSD: miidevs,v 1.78.10.2 2010/04/20 22:55:48 matt Exp
+ *	NetBSD: miidevs,v 1.78.10.5 2011/05/20 14:41:01 matt Exp
  */
 
@@ -126,4 +126,6 @@
 #define	MII_MODEL_ATTANSIC_L2	0x0002
 #define	MII_STR_ATTANSIC_L2	"L2 10/100 PHY"
+#define	MII_MODEL_ATTANSIC_AR8316	0x0004
+#define	MII_STR_ATTANSIC_AR8316	"AR8316 Switch"
 
 /* Altima Communications PHYs */
Index: /trunk/src/sys/dev/mii/miidevs_data.h
===================================================================
--- /trunk/src/sys/dev/mii/miidevs_data.h	(revision 151)
+++ /trunk/src/sys/dev/mii/miidevs_data.h	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: miidevs_data.h,v 1.71.10.2 2010/04/21 00:27:39 matt Exp $	*/
+/*	$NetBSD: miidevs_data.h,v 1.71.10.3 2011/05/20 14:42:20 matt Exp $	*/
 
 /*
@@ -5,5 +5,5 @@
  *
  * generated from:
- *	NetBSD: miidevs,v 1.78.10.2 2010/04/20 22:55:48 matt Exp
+ *	NetBSD: miidevs,v 1.78.10.5 2011/05/20 14:41:01 matt Exp
  */
 
@@ -42,4 +42,5 @@
  { MII_OUI_ATTANSIC, MII_MODEL_ATTANSIC_L1, MII_STR_ATTANSIC_L1 },
  { MII_OUI_ATTANSIC, MII_MODEL_ATTANSIC_L2, MII_STR_ATTANSIC_L2 },
+ { MII_OUI_ATTANSIC, MII_MODEL_ATTANSIC_AR8316, MII_STR_ATTANSIC_AR8316 },
  { MII_OUI_ALTIMA, MII_MODEL_ALTIMA_ACXXX, MII_STR_ALTIMA_ACXXX },
  { MII_OUI_ALTIMA, MII_MODEL_ALTIMA_AC101, MII_STR_ALTIMA_AC101 },
Index: /trunk/src/sys/dev/pci/siisata_pci.c
===================================================================
--- /trunk/src/sys/dev/pci/siisata_pci.c	(revision 151)
+++ /trunk/src/sys/dev/pci/siisata_pci.c	(revision 152)
@@ -1,3 +1,3 @@
-/* $NetBSD: siisata_pci.c,v 1.1.14.1.4.1 2010/04/21 00:27:49 matt Exp $ */
+/* $NetBSD: siisata_pci.c,v 1.1.14.1.4.2 2011/04/29 08:21:25 matt Exp $ */
 
 /*
@@ -92,4 +92,10 @@
 
 static const struct siisata_pci_board siisata_pci_boards[] = {
+	{
+		.spb_vend = PCI_VENDOR_CMDTECH,
+		.spb_prod = PCI_PRODUCT_CMDTECH_3114,
+		.spb_port = 4,
+		.spb_chip = 3114,
+	},
 	{
 		.spb_vend = PCI_VENDOR_CMDTECH,
Index: /trunk/src/sys/dev/usb/ehci.c
===================================================================
--- /trunk/src/sys/dev/usb/ehci.c	(revision 151)
+++ /trunk/src/sys/dev/usb/ehci.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: ehci.c,v 1.154.4.1 2008/11/29 20:47:05 bouyer Exp $ */
+/*	$NetBSD: ehci.c,v 1.154.4.1.4.1 2011/05/20 08:11:26 matt Exp $ */
 
 /*
@@ -53,5 +53,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: ehci.c,v 1.154.4.1 2008/11/29 20:47:05 bouyer Exp $");
+__KERNEL_RCSID(0, "$NetBSD: ehci.c,v 1.154.4.1.4.1 2011/05/20 08:11:26 matt Exp $");
 
 #include "ohci.h"
@@ -1616,9 +1616,12 @@
 		sqh->qh.qh_endphub = htole32(
 		    EHCI_QH_SET_MULT(1) |
-		    EHCI_QH_SET_HUBA(hshubaddr) |
-		    EHCI_QH_SET_PORT(hshubport) |
-		    EHCI_QH_SET_CMASK(0x08) | /* XXX */
 		    EHCI_QH_SET_SMASK(xfertype == UE_INTERRUPT ? 0x02 : 0)
 		    );
+		if (speed != EHCI_QH_SPEED_HIGH)
+			sqh->qh.qh_endphub |= htole32(
+			    EHCI_QH_SET_PORT(hshubport) |
+			    EHCI_QH_SET_HUBA(hshubaddr) |
+			    EHCI_QH_SET_CMASK(0x08) /* XXX */
+			);
 		sqh->qh.qh_curqtd = EHCI_NULL;
 		/* Fill the overlay qTD */
Index: /trunk/src/sys/gdbscripts/lwps
===================================================================
--- /trunk/src/sys/gdbscripts/lwps	(revision 151)
+++ /trunk/src/sys/gdbscripts/lwps	(revision 152)
@@ -1,3 +1,3 @@
-#	$NetBSD: lwps,v 1.1 2008/02/20 20:56:35 ad Exp $
+#	$NetBSD: lwps,v 1.1.32.1 2011/05/20 08:11:27 matt Exp $
 
 define lwps
@@ -20,5 +20,5 @@
 					printf " (%s)", (char *)$l->l_wmesg
 				end
-				set $l = $l->l_list.le_next
+				set $l = $l->l_sibling.le_next
 				printf "\n"
 				set $j++
Index: /trunk/src/sys/kern/exec_subr.c
===================================================================
--- /trunk/src/sys/kern/exec_subr.c	(revision 151)
+++ /trunk/src/sys/kern/exec_subr.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: exec_subr.c,v 1.61.8.1 2009/04/01 00:25:22 snj Exp $	*/
+/*	$NetBSD: exec_subr.c,v 1.61.8.1.4.1 2011/05/20 08:11:27 matt Exp $	*/
 
 /*
@@ -32,5 +32,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: exec_subr.c,v 1.61.8.1 2009/04/01 00:25:22 snj Exp $");
+__KERNEL_RCSID(0, "$NetBSD: exec_subr.c,v 1.61.8.1.4.1 2011/05/20 08:11:27 matt Exp $");
 
 #include "opt_pax.h"
@@ -387,4 +387,5 @@
 		max_stack_size = MAXSSIZ;
 	}
+	epp->ep_ssize = l->l_proc->p_rlimit[RLIMIT_STACK].rlim_cur;
 
 #ifdef PAX_ASLR
@@ -396,5 +397,4 @@
 	epp->ep_maxsaddr = (u_long)STACK_GROW(epp->ep_minsaddr,
 		max_stack_size);
-	epp->ep_ssize = l->l_proc->p_rlimit[RLIMIT_STACK].rlim_cur;
 
 	/*
@@ -411,9 +411,9 @@
 	noaccess_linear_min = (u_long)STACK_ALLOC(STACK_GROW(epp->ep_minsaddr,
 	    access_size), noaccess_size);
-	if (noaccess_size > 0) {
+	if (noaccess_size > 0 && noaccess_size <= MAXSSIZ) {
 		NEW_VMCMD2(&epp->ep_vmcmds, vmcmd_map_zero, noaccess_size,
 		    noaccess_linear_min, NULL, 0, VM_PROT_NONE, VMCMD_STACK);
 	}
-	KASSERT(access_size > 0);
+	KASSERT(access_size > 0 && access_size <= MAXSSIZ);
 	NEW_VMCMD2(&epp->ep_vmcmds, vmcmd_map_zero, access_size,
 	    access_linear_min, NULL, 0, VM_PROT_READ | VM_PROT_WRITE,
Index: /trunk/src/sys/kern/kern_cctr.c
===================================================================
--- /trunk/src/sys/kern/kern_cctr.c	(revision 151)
+++ /trunk/src/sys/kern/kern_cctr.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: kern_cctr.c,v 1.8 2008/05/19 17:06:02 ad Exp $	*/
+/*	$NetBSD: kern_cctr.c,v 1.8.14.1 2011/02/05 06:00:13 cliff Exp $	*/
 
 /*-
@@ -76,5 +76,7 @@
 #include <sys/cdefs.h>
 /* __FBSDID("$FreeBSD: src/sys/i386/i386/tsc.c,v 1.204 2003/10/21 18:28:34 silby Exp $"); */
-__KERNEL_RCSID(0, "$NetBSD: kern_cctr.c,v 1.8 2008/05/19 17:06:02 ad Exp $");
+__KERNEL_RCSID(0, "$NetBSD: kern_cctr.c,v 1.8.14.1 2011/02/05 06:00:13 cliff Exp $");
+
+#include "opt_multiprocessor.h"
 
 #include <sys/param.h>
Index: /trunk/src/sys/kern/kern_exec.c
===================================================================
--- /trunk/src/sys/kern/kern_exec.c	(revision 151)
+++ /trunk/src/sys/kern/kern_exec.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: kern_exec.c,v 1.280.4.3.4.1 2010/04/21 00:28:16 matt Exp $	*/
+/*	$NetBSD: kern_exec.c,v 1.280.4.3.4.3 2011/04/29 08:20:14 matt Exp $	*/
 
 /*-
@@ -60,5 +60,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: kern_exec.c,v 1.280.4.3.4.1 2010/04/21 00:28:16 matt Exp $");
+__KERNEL_RCSID(0, "$NetBSD: kern_exec.c,v 1.280.4.3.4.3 2011/04/29 08:20:14 matt Exp $");
 
 #include "opt_ktrace.h"
@@ -1034,6 +1034,9 @@
 		(*pack.ep_esch->es_setregs)(l, &pack, (u_long) stack);
 
+	/* Provide a consistent LWP private setting */
+	(void)lwp_setprivate(l, NULL);
+
 	/* map the process's signal trampoline code */
-	if (exec_sigcode_map(p, pack.ep_esch->es_emul)) {
+	if ((error = exec_sigcode_map(p, pack.ep_esch->es_emul)) != 0) {
 		DPRINTF(("execve: map sigcode failed %d\n", error));
 		goto exec_abort;
@@ -1208,6 +1211,8 @@
 	argc = arginfo->ps_nargvstr;
 	envc = arginfo->ps_nenvstr;
-	if ((error = copyout(&argc, cpp++, sizeof(argc))) != 0)
+	if ((error = copyout(&argc, cpp++, sizeof(argc))) != 0) {
+		DPRINTF(("copyargs:%d copyout @%p %zu\n", __LINE__, cpp-1, sizeof(argc)));
 		return error;
+	}
 
 	dp = (char *) (cpp + argc + envc + 2 + pack->ep_esch->es_arglen);
@@ -1217,21 +1222,37 @@
 	arginfo->ps_argvstr = cpp; /* remember location of argv for later */
 
-	for (; --argc >= 0; sp += len, dp += len)
-		if ((error = copyout(&dp, cpp++, sizeof(dp))) != 0 ||
-		    (error = copyoutstr(sp, dp, ARG_MAX, &len)) != 0)
+	for (; --argc >= 0; sp += len, dp += len) {
+		if ((error = copyout(&dp, cpp++, sizeof(dp))) != 0) {
+			DPRINTF(("copyargs:%d copyout @%p %zu\n", __LINE__, cpp-1, sizeof(dp)));
 			return error;
-
-	if ((error = copyout(&nullp, cpp++, sizeof(nullp))) != 0)
+		}
+		if ((error = copyoutstr(sp, dp, ARG_MAX, &len)) != 0) {
+			DPRINTF(("copyargs:%d copyoutstr @%p %u\n", __LINE__, dp, ARG_MAX));
+			return error;
+		}
+	}
+
+	if ((error = copyout(&nullp, cpp++, sizeof(nullp))) != 0) {
+		DPRINTF(("copyargs:%d copyout @%p %zu\n", __LINE__, cpp-1, sizeof(nullp)));
 		return error;
+	}
 
 	arginfo->ps_envstr = cpp; /* remember location of envp for later */
 
-	for (; --envc >= 0; sp += len, dp += len)
-		if ((error = copyout(&dp, cpp++, sizeof(dp))) != 0 ||
-		    (error = copyoutstr(sp, dp, ARG_MAX, &len)) != 0)
+	for (; --envc >= 0; sp += len, dp += len) {
+		if ((error = copyout(&dp, cpp++, sizeof(dp))) != 0) {
+			DPRINTF(("copyargs:%d copyout @%p %zu\n", __LINE__, cpp-1, sizeof(dp)));
 			return error;
-
-	if ((error = copyout(&nullp, cpp++, sizeof(nullp))) != 0)
+		}
+		if ((error = copyoutstr(sp, dp, ARG_MAX, &len)) != 0) {
+			DPRINTF(("copyargs:%d copyoutstr @%p %u\n", __LINE__, dp, ARG_MAX));
+			return error;
+		}
+	}
+
+	if ((error = copyout(&nullp, cpp++, sizeof(nullp))) != 0) {
+		DPRINTF(("copyargs:%d copyout @%p %zu\n", __LINE__, cpp-1, sizeof(nullp)));
 		return error;
+	}
 
 	*stackp = (char *)cpp;
@@ -1669,4 +1690,8 @@
 				    UVM_ADV_RANDOM, 0));
 	if (error) {
+		DPRINTF(("exec_sigcode_map:%d map %p "
+		    "uvm_map %#"PRIxVSIZE"@%#"PRIxVADDR" failed %d\n",
+		    __LINE__, &p->p_vmspace->vm_map, round_page(sz), va,
+		    error));
 		(*uobj->pgops->pgo_detach)(uobj);
 		return (error);
Index: /trunk/src/sys/kern/kern_fork.c
===================================================================
--- /trunk/src/sys/kern/kern_fork.c	(revision 151)
+++ /trunk/src/sys/kern/kern_fork.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: kern_fork.c,v 1.171 2008/10/11 13:40:57 pooka Exp $	*/
+/*	$NetBSD: kern_fork.c,v 1.171.10.1 2011/04/29 08:20:15 matt Exp $	*/
 
 /*-
@@ -68,5 +68,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: kern_fork.c,v 1.171 2008/10/11 13:40:57 pooka Exp $");
+__KERNEL_RCSID(0, "$NetBSD: kern_fork.c,v 1.171.10.1 2011/04/29 08:20:15 matt Exp $");
 
 #include "opt_ktrace.h"
@@ -295,7 +295,9 @@
 	 * Inherit flags we want to keep.  The flags related to SIGCHLD
 	 * handling are important in order to keep a consistent behaviour
-	 * for the child after the fork.
-	 */
-	p2->p_flag = p1->p_flag & (PK_SUGID | PK_NOCLDWAIT | PK_CLDSIGIGN);
+	 * for the child after the fork.  If we are a 32-bit process, the
+	 * child will be too. 
+	 */
+	p2->p_flag =
+	    p1->p_flag & (PK_SUGID | PK_NOCLDWAIT | PK_CLDSIGIGN | PK_32);
 	p2->p_emul = p1->p_emul;
 	p2->p_execsw = p1->p_execsw;
@@ -435,4 +437,5 @@
 	    stack, stacksize, (func != NULL) ? func : child_return, arg, &l2,
 	    l1->l_class);
+	lwp_setprivate(l2, l1->l_private);
 
 	/*
Index: /trunk/src/sys/kern/kern_lwp.c
===================================================================
--- /trunk/src/sys/kern/kern_lwp.c	(revision 151)
+++ /trunk/src/sys/kern/kern_lwp.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: kern_lwp.c,v 1.126.2.2 2009/03/08 03:15:36 snj Exp $	*/
+/*	$NetBSD: kern_lwp.c,v 1.126.2.2.4.2 2011/04/29 08:20:15 matt Exp $	*/
 
 /*-
@@ -207,6 +207,7 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: kern_lwp.c,v 1.126.2.2 2009/03/08 03:15:36 snj Exp $");
-
+__KERNEL_RCSID(0, "$NetBSD: kern_lwp.c,v 1.126.2.2.4.2 2011/04/29 08:20:15 matt Exp $");
+
+#include "opt_multiprocessor.h"
 #include "opt_ddb.h"
 #include "opt_lockdebug.h"
@@ -1721,4 +1722,19 @@
 }
 
+/*      
+ * Set an LWP's private data pointer.
+ */     
+int             
+lwp_setprivate(lwp_t *l, void *ptr)
+{               
+	int error = 0;  
+
+	l->l_private = ptr;
+#ifdef __HAVE_CPU_LWP_SETPRIVATE
+	error = cpu_lwp_setprivate(l, ptr); 
+#endif  
+	return error;
+}
+
 #if defined(DDB)
 void
Index: /trunk/src/sys/kern/kern_malloc_debug.c
===================================================================
--- /trunk/src/sys/kern/kern_malloc_debug.c	(revision 151)
+++ /trunk/src/sys/kern/kern_malloc_debug.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: kern_malloc_debug.c,v 1.20 2008/08/07 01:40:21 matt Exp $	*/
+/*	kern_malloc_debug.c,v 1.20 2008/08/07 01:40:21 matt Exp	*/
 
 /*
@@ -57,5 +57,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: kern_malloc_debug.c,v 1.20 2008/08/07 01:40:21 matt Exp $");
+__KERNEL_RCSID(0, "kern_malloc_debug.c,v 1.20 2008/08/07 01:40:21 matt Exp");
 
 #include <sys/param.h>
@@ -241,5 +241,5 @@
 	offset = va - vm_map_min(kernel_map);
 	for (;;) {
-		pg = uvm_pagealloc(NULL, offset, NULL, 0);
+		pg = uvm_pagealloc(NULL, offset, NULL, UVM_FLAG_COLORMATCH);
 		if (pg) {
 			pg->flags &= ~PG_BUSY;  /* new page */
Index: /trunk/src/sys/kern/kern_mutex.c
===================================================================
--- /trunk/src/sys/kern/kern_mutex.c	(revision 151)
+++ /trunk/src/sys/kern/kern_mutex.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: kern_mutex.c,v 1.44 2008/10/15 06:51:20 wrstuden Exp $	*/
+/*	$NetBSD: kern_mutex.c,v 1.44.10.1 2011/02/05 06:00:13 cliff Exp $	*/
 
 /*-
@@ -41,5 +41,7 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: kern_mutex.c,v 1.44 2008/10/15 06:51:20 wrstuden Exp $");
+__KERNEL_RCSID(0, "$NetBSD: kern_mutex.c,v 1.44.10.1 2011/02/05 06:00:13 cliff Exp $");
+
+#include "opt_multiprocessor.h"
 
 #include <sys/param.h>
Index: /trunk/src/sys/kern/kern_pax.c
===================================================================
--- /trunk/src/sys/kern/kern_pax.c	(revision 151)
+++ /trunk/src/sys/kern/kern_pax.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: kern_pax.c,v 1.22 2008/06/04 12:26:20 ad Exp $	*/
+/*	$NetBSD: kern_pax.c,v 1.22.16.1 2011/05/20 08:11:27 matt Exp $	*/
 
 /*-
@@ -29,5 +29,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: kern_pax.c,v 1.22 2008/06/04 12:26:20 ad Exp $");
+__KERNEL_RCSID(0, "$NetBSD: kern_pax.c,v 1.22.16.1 2011/05/20 08:11:27 matt Exp $");
 
 #include "opt_pax.h"
@@ -354,4 +354,6 @@
 		epp->ep_minsaddr -= d;
 		*max_stack_size -= d;
+		if (epp->ep_ssize > *max_stack_size)
+			epp->ep_ssize = *max_stack_size;
 	}
 }
Index: /trunk/src/sys/kern/kern_runq.c
===================================================================
--- /trunk/src/sys/kern/kern_runq.c	(revision 151)
+++ /trunk/src/sys/kern/kern_runq.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: kern_runq.c,v 1.22.4.3.4.1 2010/04/21 00:28:16 matt Exp $	*/
+/*	$NetBSD: kern_runq.c,v 1.22.4.3.4.2 2011/02/05 06:00:14 cliff Exp $	*/
 
 /*
@@ -28,5 +28,7 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: kern_runq.c,v 1.22.4.3.4.1 2010/04/21 00:28:16 matt Exp $");
+__KERNEL_RCSID(0, "$NetBSD: kern_runq.c,v 1.22.4.3.4.2 2011/02/05 06:00:14 cliff Exp $");
+
+#include "opt_multiprocessor.h"
 
 #include <sys/param.h>
Index: /trunk/src/sys/kern/kern_rwlock.c
===================================================================
--- /trunk/src/sys/kern/kern_rwlock.c	(revision 151)
+++ /trunk/src/sys/kern/kern_rwlock.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: kern_rwlock.c,v 1.28.10.2.2.1 2010/04/21 00:28:17 matt Exp $	*/
+/*	$NetBSD: kern_rwlock.c,v 1.28.10.2.2.2 2011/02/05 06:00:14 cliff Exp $	*/
 
 /*-
@@ -39,5 +39,7 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: kern_rwlock.c,v 1.28.10.2.2.1 2010/04/21 00:28:17 matt Exp $");
+__KERNEL_RCSID(0, "$NetBSD: kern_rwlock.c,v 1.28.10.2.2.2 2011/02/05 06:00:14 cliff Exp $");
+
+#include "opt_multiprocessor.h"
 
 #define	__RWLOCK_PRIVATE
Index: /trunk/src/sys/kern/kern_stub.c
===================================================================
--- /trunk/src/sys/kern/kern_stub.c	(revision 151)
+++ /trunk/src/sys/kern/kern_stub.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: kern_stub.c,v 1.11 2008/10/15 16:03:29 wrstuden Exp $	*/
+/*	$NetBSD: kern_stub.c,v 1.11.8.1 2011/02/05 06:00:14 cliff Exp $	*/
 
 /*-
@@ -63,6 +63,7 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: kern_stub.c,v 1.11 2008/10/15 16:03:29 wrstuden Exp $");
-
+__KERNEL_RCSID(0, "$NetBSD: kern_stub.c,v 1.11.8.1 2011/02/05 06:00:14 cliff Exp $");
+
+#include "opt_multiprocessor.h"
 #include "opt_ptrace.h"
 #include "opt_ktrace.h"
Index: /trunk/src/sys/kern/kern_subr.c
===================================================================
--- /trunk/src/sys/kern/kern_subr.c	(revision 151)
+++ /trunk/src/sys/kern/kern_subr.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: kern_subr.c,v 1.192.4.1.4.2 2010/01/26 04:51:03 cliff Exp $	*/
+/*	$NetBSD: kern_subr.c,v 1.192.4.1.4.4 2010/06/10 00:42:16 cliff Exp $	*/
 
 /*-
@@ -80,5 +80,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: kern_subr.c,v 1.192.4.1.4.2 2010/01/26 04:51:03 cliff Exp $");
+__KERNEL_RCSID(0, "$NetBSD: kern_subr.c,v 1.192.4.1.4.4 2010/06/10 00:42:16 cliff Exp $");
 
 #include "opt_ddb.h"
@@ -974,9 +974,11 @@
 		 */
 
+		dv = finddevice(rootspec);
+
 		/*
-		 * if rootspec is not configured, ask (again)
+		 * if the lookup failed and we have no rootdev
+		 * then we have to ask
 		 */
-		dv = finddevice(rootspec);
-		if (dv == NULL) {
+		if (dv == NULL && rootdev == NODEV) {
 			printf("device %s not configured\n", rootspec);
 			boothowto |= RB_ASKNAME;
@@ -988,10 +990,10 @@
 		 * early.
 		 */
-		if (device_class(dv) == DV_IFNET) {
+		if (dv != NULL && device_class(dv) == DV_IFNET) {
 			rootdv = dv;
 			goto haveroot;
 		}
 
-		if (rootdev == NODEV &&
+		if (dv != NULL && rootdev == NODEV &&
 		    device_class(dv) == DV_DISK && device_is_a(dv, "dk") &&
 		    (majdev = devsw_name2blk(device_xname(dv), NULL, 0)) >= 0)
Index: /trunk/src/sys/kern/kern_verifiedexec.c
===================================================================
--- /trunk/src/sys/kern/kern_verifiedexec.c	(revision 151)
+++ /trunk/src/sys/kern/kern_verifiedexec.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: kern_verifiedexec.c,v 1.111.4.1 2008/12/18 00:56:27 snj Exp $	*/
+/*	kern_verifiedexec.c,v 1.111.4.1 2008/12/18 00:56:27 snj Exp	*/
 
 /*-
@@ -30,5 +30,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: kern_verifiedexec.c,v 1.111.4.1 2008/12/18 00:56:27 snj Exp $");
+__KERNEL_RCSID(0, "kern_verifiedexec.c,v 1.111.4.1 2008/12/18 00:56:27 snj Exp");
 
 #include "opt_veriexec.h"
@@ -766,5 +766,6 @@
 	ctx = kmem_alloc(vfe->ops->context_size, KM_SLEEP);
 	fp = kmem_alloc(vfe->ops->hash_len, KM_SLEEP);
-	kva = uvm_km_alloc(kernel_map, PAGE_SIZE, 0, UVM_KMF_VAONLY | UVM_KMF_WAITVA);
+	kva = uvm_km_alloc(kernel_map, PAGE_SIZE, VM_PAGE_TO_COLOR(pg),
+	    UVM_KMF_COLORMATCH | UVM_KMF_VAONLY | UVM_KMF_WAITVA);
 	pmap_kenter_pa(kva, VM_PAGE_TO_PHYS(pg), VM_PROT_READ);
 	pmap_update(pmap_kernel());
Index: /trunk/src/sys/kern/subr_autoconf.c
===================================================================
--- /trunk/src/sys/kern/subr_autoconf.c	(revision 151)
+++ /trunk/src/sys/kern/subr_autoconf.c	(revision 152)
@@ -1,3 +1,3 @@
-/* $NetBSD: subr_autoconf.c,v 1.163.4.2 2009/03/15 19:43:48 snj Exp $ */
+/* $NetBSD: subr_autoconf.c,v 1.163.4.2.4.3 2011/02/08 21:56:01 cliff Exp $ */
 
 /*
@@ -78,6 +78,7 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: subr_autoconf.c,v 1.163.4.2 2009/03/15 19:43:48 snj Exp $");
-
+__KERNEL_RCSID(0, "$NetBSD: subr_autoconf.c,v 1.163.4.2.4.3 2011/02/08 21:56:01 cliff Exp $");
+
+#include "opt_multiprocessor.h"
 #include "opt_ddb.h"
 #include "drvctl.h"
@@ -197,4 +198,19 @@
 
 TAILQ_HEAD(deferred_config_head, deferred_config);
+
+/*
+ * config_queues_lock protects MP access to
+ * - deferred_config_queue
+ * - interrupt_config_queue
+ * is held for short durations, and is initialized to spin
+ */
+static kmutex_t *config_queues_lock;
+
+/*
+ * dc_funcs_lock ensures the driver dc_func's are not called concurrently
+ * many (most?) are not MP safe
+ * is held for unknown durations, and is initialized to sleep
+ */
+static kmutex_t *dc_funcs_lock;
 
 struct deferred_config_head deferred_config_queue =
@@ -361,4 +377,7 @@
 	cv_init(&config_misc_cv, "cfgmisc");
 
+	dc_funcs_lock = mutex_obj_alloc(MUTEX_DEFAULT, IPL_SOFTNET);
+	config_queues_lock = mutex_obj_alloc(MUTEX_DEFAULT, IPL_VM);
+
 	/* allcfdrivers is statically initialized. */
 	for (i = 0; cfdriver_list_initial[i] != NULL; i++) {
@@ -397,10 +416,17 @@
 	struct deferred_config *dc;
 
+	mutex_enter(config_queues_lock);
 	while ((dc = TAILQ_FIRST(&interrupt_config_queue)) != NULL) {
 		TAILQ_REMOVE(&interrupt_config_queue, dc, dc_queue);
+		mutex_exit(config_queues_lock);
+		mutex_enter(dc_funcs_lock);
 		(*dc->dc_func)(dc->dc_dev);
+		mutex_exit(dc_funcs_lock);
 		kmem_free(dc, sizeof(*dc));
 		config_pending_decr();
-	}
+		mutex_enter(config_queues_lock);
+	}
+	mutex_exit(config_queues_lock);
+
 	kthread_exit(0);
 }
@@ -1651,4 +1677,5 @@
 
 #ifdef DIAGNOSTIC
+	mutex_enter(config_queues_lock);
 	for (dc = TAILQ_FIRST(&deferred_config_queue); dc != NULL;
 	     dc = TAILQ_NEXT(dc, dc_queue)) {
@@ -1656,4 +1683,5 @@
 			panic("config_defer: deferred twice");
 	}
+	mutex_exit(config_queues_lock);
 #endif
 
@@ -1664,5 +1692,9 @@
 	dc->dc_dev = dev;
 	dc->dc_func = func;
+
+	mutex_enter(config_queues_lock);
 	TAILQ_INSERT_TAIL(&deferred_config_queue, dc, dc_queue);
+	mutex_exit(config_queues_lock);
+
 	config_pending_incr();
 }
@@ -1687,4 +1719,5 @@
 
 #ifdef DIAGNOSTIC
+	mutex_enter(config_queues_lock);
 	for (dc = TAILQ_FIRST(&interrupt_config_queue); dc != NULL;
 	     dc = TAILQ_NEXT(dc, dc_queue)) {
@@ -1692,4 +1725,5 @@
 			panic("config_interrupts: deferred twice");
 	}
+	mutex_exit(config_queues_lock);
 #endif
 
@@ -1700,5 +1734,7 @@
 	dc->dc_dev = dev;
 	dc->dc_func = func;
+	mutex_enter(config_queues_lock);
 	TAILQ_INSERT_TAIL(&interrupt_config_queue, dc, dc_queue);
+	mutex_exit(config_queues_lock);
 	config_pending_incr();
 }
@@ -1713,13 +1749,19 @@
 	struct deferred_config *dc, *ndc;
 
+	mutex_enter(config_queues_lock);
 	for (dc = TAILQ_FIRST(queue); dc != NULL; dc = ndc) {
 		ndc = TAILQ_NEXT(dc, dc_queue);
 		if (parent == NULL || dc->dc_dev->dv_parent == parent) {
 			TAILQ_REMOVE(queue, dc, dc_queue);
+			mutex_exit(config_queues_lock);
+			mutex_enter(dc_funcs_lock);
 			(*dc->dc_func)(dc->dc_dev);
+			mutex_exit(dc_funcs_lock);
 			kmem_free(dc, sizeof(*dc));
 			config_pending_decr();
+			mutex_enter(config_queues_lock);
 		}
 	}
+	mutex_exit(config_queues_lock);
 }
 
Index: /trunk/src/sys/kern/subr_evcnt.c
===================================================================
--- /trunk/src/sys/kern/subr_evcnt.c	(revision 151)
+++ /trunk/src/sys/kern/subr_evcnt.c	(revision 152)
@@ -1,3 +1,3 @@
-/* $NetBSD: subr_evcnt.c,v 1.4 2005/12/11 12:24:30 christos Exp $ */
+/* $NetBSD: subr_evcnt.c,v 1.4.94.2 2011/02/05 06:54:58 cliff Exp $ */
 
 /*
@@ -78,5 +78,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: subr_evcnt.c,v 1.4 2005/12/11 12:24:30 christos Exp $");
+__KERNEL_RCSID(0, "$NetBSD: subr_evcnt.c,v 1.4.94.2 2011/02/05 06:54:58 cliff Exp $");
 
 #include "opt_ddb.h"
@@ -84,8 +84,10 @@
 #include <sys/param.h>
 #include <sys/device.h>
+#include <sys/mutex.h>
 #include <sys/systm.h>
 
 /* list of all events */
 struct evcntlist allevents = TAILQ_HEAD_INITIALIZER(allevents);
+static kmutex_t evcnt_lock;
 
 /*
@@ -105,4 +107,6 @@
 	__link_set_decl(evcnts, struct evcnt);
 	struct evcnt * const *evp;
+
+	mutex_init(&evcnt_lock, MUTEX_DEFAULT, IPL_NONE);
 
 	__link_set_foreach(evp, evcnts) {
@@ -136,5 +140,7 @@
 	ev->ev_namelen = len;
 
+	mutex_enter(&evcnt_lock);
 	TAILQ_INSERT_TAIL(&allevents, ev, ev_list);
+	mutex_exit(&evcnt_lock);
 }
 
@@ -163,5 +169,7 @@
 {
 
+	mutex_enter(&evcnt_lock);
 	TAILQ_REMOVE(&allevents, ev, ev_list);
+	mutex_exit(&evcnt_lock);
 }
 
Index: /trunk/src/sys/kern/sys_lwp.c
===================================================================
--- /trunk/src/sys/kern/sys_lwp.c	(revision 151)
+++ /trunk/src/sys/kern/sys_lwp.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: sys_lwp.c,v 1.43 2008/10/16 08:47:07 ad Exp $	*/
+/*	$NetBSD: sys_lwp.c,v 1.43.10.1 2011/04/29 08:20:15 matt Exp $	*/
 
 /*-
@@ -36,5 +36,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: sys_lwp.c,v 1.43 2008/10/16 08:47:07 ad Exp $");
+__KERNEL_RCSID(0, "$NetBSD: sys_lwp.c,v 1.43.10.1 2011/04/29 08:20:15 matt Exp $");
 
 #include <sys/param.h>
@@ -186,6 +186,5 @@
 	} */
 
-	l->l_private = SCARG(uap, ptr);
-	return 0;
+	return lwp_setprivate(l, SCARG(uap, ptr));
 }
 
